#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <network.h>
#include <socket.h>
#include "porter.h"

typedef struct {
	void	*next;
	char	buf[128];
} ADRCHAIN;


static int sock25;


/* clear address chain */
static void
clr_chain (ADRCHAIN **mother)
{
	ADRCHAIN	*parent, *child;

	parent = *mother;
	while (parent) {
		child = parent->next;
		free(parent);
		parent = child;
	}
	*mother = NULL;
}

/* skip spaces in string */
static char *skipspace (char *str)
{
	char	*p = str;

	while (*p && *p <= ' ')	p++;
	return p;
}

/* extract mail address from mime header */
static char *getaddress (char *dest, char *str)

{
	char *r = skipspace (str);
	char *w = dest;

	while (TRUE) {
		if (!*r || *r == ',') {
			break;
		} else if (*r == '\"') {
			/* skip quoted string */
			while (*r && *r != '\"')	r++;
			if (*r)	r = skipspace (++r);

		} else if (*r == '(') {
			/* skip (comment) */
			while (*r && *r != ')')	r++;
			if (*r)	r = skipspace (++r);

		} else if (*r == '<') {
			/* get <address> */
			r = skipspace (++r);
			w = dest;
			while (*r && *r != '>')	*w++ = *r++;
			if (*r)	r = skipspace (++r);

		} else {
			*w++ = *r++;
		}
	}

	/* delete post-placed spaces */
	while (dest < w && w[-1] <= ' ')	--w;
	*w = '\0';

	/* skip comma */
	if (*r)	r++;
	return r;
}

/* clear chain */
static int add_chain(struct _porter *q, ADRCHAIN **mother, char *str)
{
	ADRCHAIN *parent = *mother;
	char *p = str;

	while (*p) {
		ADRCHAIN *child = malloc (sizeof(ADRCHAIN));

		if (!child) {
			fputs ("܂\n", stdout);
			clr_chain (mother);
			return FALSE;
		}
		p = getaddress (child->buf, p);
		if (!child->buf[0]) {
			free (child);
			break;
		}

		/* add domain name if not found */
		if (!strchr (child->buf, '@')) {
			strcat (child->buf, q->HostName);
		}

		child->next = NULL;
		if (parent) {
			parent->next = child;
		} else {
			*mother = child;
		}
		parent = child;
	}
	return TRUE;
}


/* w肳ꂽ\Pbg烁bZ[W󂯎ĕ\ */
static int ReceiveMessage (int sock)
{
	char temp_str[1024];
	int r;

	/* 肩瑗Ă\ */
	VerbosePrintf ("ReceiveMessage()\n	M҂܂\n");
	while (!socklen (sock, 0));	/* M҂ */
	do {
		recvline (sock, temp_str, 1024);	/* M */
		VerbosePrintf ("	肩 : %s", temp_str);
	} while (socklen (sock, 0) > 0);

	sscanf (temp_str, "%d *", &r);
	return (r);
}



/* w肳ꂽ\PbgɃbZ[W𑗂 */
static void SendMessage (int sock, char *mes)
{
	VerbosePrintf ("SendMessage()\n	郁bZ[W : %s", mes);
	write_s (sock, mes, strlen (mes));	/* M */
	//usflush (sock);
	VerbosePrintf ("	Mobt@ɂȂ̂҂܂\n");
	while (socklen (sock, 1));	/* Mobt@Ƀf[^邤͑҂ */

	return;
}



/* w肳ꂽ\PbgɃR}h𑗂ăX|X\ */
static int SendCommand (int sock, char *cmd)
{
	int r;

	VerbosePrintf ("SendCommand()\n	R}h : %s", cmd);	/* R}h\ */
	write_s (sock, cmd, strlen (cmd));	/* M */
	//usflush (sock);
	VerbosePrintf ("	Mobt@ɂȂ̂҂܂\n");
	while (socklen (sock, 1));	/* Mobt@Ƀf[^邤͑҂ */
	r = ReceiveMessage (sock);

	return (r);
}



/* \PbgI[v */
static int OpenSock (char *hostname, int port)
{
	int sock;
	struct hostent *h;
	struct sockaddr_in addr;

	/* \Pbg쐬 */
	if ((sock = socket (AF_INET, SOCK_STREAM, 0)) < 0) {
		printf ("	G[ : \Pbg쐬ł܂ł\n");
		return (-1);
	}
	memset (&addr, 0, sizeof (addr));	/* 0 Ŗ߂ */

	addr.sin_family = AF_INET;	/* INEThCw */
	addr.sin_port = htons (port);	/* |[gԍ */
	/* zXgimankai.co.jpj  IP AhX(int)ɕϊ */
	if ((h = gethostbyname (hostname)) == NULL) {
		printf ("	G[ : hC݂܂\n");
		return (-1);
	}
	addr.sin_addr.s_addr = *(long *) h->h_addr;

	/* ɐڑ */
	printf ("	ڑ...\n");
	if (connect (sock, (char *) &addr, sizeof (addr)) < 0) {
		printf ("	G[ : ڑɎs܂\n");
		return (-1);
	}
	printf ("ڑ܂\n");
	return (sock);
}



/* \PbgN[Y */
static void CloseSock (int sock)
{
	if (sock > 0) {
		//while (socklen (sock, 0));	/* Mobt@Ƀf[^邤͑҂ */
		//while (socklen (sock, 1));	/* M@@@@@@@V@@@@@@@@ */
		//shutdown (sock, 0);	/* Mf[^󂯎炸CׂĔp */
		//shutdown (sock, 1);	/* TCP FIN𑗐MCf[^̑o߂ */
		//shutdown (sock, 2);	/* connection  abort */
		close_s (sock);
	}
}



int PostOne (struct _porter *q, char *fname)
{
#define LINE_MAX	1024
	int r;
	FILE *fp;
	ADRCHAIN	*to_chain = NULL, *child;
	char *ptr;
	char temp_str[LINE_MAX], temp_str2[LINE_MAX];

	VerbosePrintf ("PostOne()\n");
	fp = fopen (fname, "r");
	if (fp == NULL) {
		printf ("%s ǂݍ߂܂\n", fname);
		return (-1);
	}

	while (fgets822b (temp_str, sizeof(temp_str), fp)) {
		if ((ptr = GetKeyword (temp_str, "TO:"))
				|| (ptr = GetKeyword (temp_str, "BCC:"))
				|| (ptr = GetKeyword (temp_str, "CC:"))) {
			if (!add_chain (q, &to_chain, ptr)) {
				fclose (fp);
				return (-2);
			}
		}
	}
	if (!to_chain) {
		fputs ("悪܂\n", stdout);
		fclose (fp);
		return (-1);
	}

	/* back to the top of file */
	fseek(fp, SEEK_SET, 0);

	sprintf (temp_str, "MAIL FROM:<%s>\r\n", q->MailAdress);
	r = SendCommand (sock25, temp_str);

	child = to_chain;
	while (child) {
		sprintf (temp_str, "RCPT TO:<%s>\r\n", child->buf);
		r = SendCommand (sock25, temp_str);
		child = child->next;
	}
	clr_chain (&to_chain);

	sprintf (temp_str, "DATA\r\n");
	r = SendCommand (sock25, temp_str);

	/* wb_𑗂 */
	while (fgets (temp_str, sizeof(temp_str), fp)) {
		if (ferror (fp) || feof (fp))	break;
		if (headicmp (temp_str, "BCC:")) {
			/* o͂Ȃ */
			while (fgets (temp_str, sizeof(temp_str), fp)) {
				if (temp_str[0] != ' ' && temp_str[0] != '\t')
					break;
			}
			if (ferror (fp) || feof (fp))	break;
			if (temp_str[0] == '\r' || temp_str[0] == '\n')
				break;
		}
		SendMessage (sock25, temp_str);
	}
	SendMessage (sock25, "\r\n");

	/* fname PsǂݍőM */
	while (fgets (temp_str2, LINE_MAX, fp) != NULL) {
		if (ferror (fp) || feof (fp))
			break;
		if (!strcmpi (temp_str2, "."))	/* "." Ȃ ".." ɒu */
			sprintf (temp_str, "..");
		else
			sprintf (temp_str, "%s", temp_str2);
		SendMessage (sock25, temp_str);
	}
	r = SendCommand (sock25, ".\r\n");	/* f[^I */

	fclose (fp);

	return (0);
}



int LoginSession (char *hostname)
{
	int r;
	char temp_str[256];
	int login_ok = 0;

	if ((sock25 = OpenSock (hostname, 25)) < 0)
		return (-2);

	VerbosePrintf ("LoginSession()\n");

	r = ReceiveMessage (sock25);

	do {
		switch (r) {
		case 220:
			sprintf (temp_str, "HELO %s\r\n", hostname);
			r = SendCommand (sock25, temp_str);
			break;
		case 250:
			login_ok = !0;
			break;
		default:
			return (-1);
			break;
		}
	} while (!login_ok);

	return (0);
}


int LogoffSession (void)
{
	SendCommand (sock25, "QUIT\r\n");
	CloseSock (sock25);

	return (0);
}
